diff --git a/build/win32/project/Makefile_tls.inc b/build/win32/project/Makefile_tls.inc
index ca13ca2..29615db 100644
--- a/build/win32/project/Makefile_tls.inc
+++ b/build/win32/project/Makefile_tls.inc
@@ -1,7 +1,7 @@
 !IF "$(TLS)" != ""
 
-!	IF "$(TLS)" != "mbedtls" && "$(TLS)" != "gnutls" && "$(TLS)" != "openssl"
-!		ERROR Specified TLS target "$(TLS)" is not supported (supported: mbedtls, gnutls, openssl).
+!	IF "$(TLS)" != "mbedtls" && "$(TLS)" != "mbedtls21" && "$(TLS)" != "gnutls" && "$(TLS)" != "openssl"
+!		ERROR Specified TLS target "$(TLS)" is not supported (supported: mbedtls, mbedtls21, gnutls, openssl).
 !	ENDIF
 
 !	IF "$(TLSINCDIR)" == ""
@@ -20,6 +20,10 @@
 !		IF "$(TLSLIB)" == ""
 !			ERROR Please specify full path to static GnuTLS library (e. g. TLSLIB="\somepath\some.lib").
 !		ENDIF
+!	ELSEIF "$(TLS)" == "mbedtls21"
+!		IF ("$(TLSLIBDIR)" == "" || "$(TLSLIB)" != "" || "$(TLSLIB2)" != "" || "$(TLSLIB3)" != "") && ("$(TLSLIBDIR)" != "" || "$(TLSLIB)" == "" || "$(TLSLIB2)" == "" || "$(TLSLIB3)" == "")
+!			ERROR Please specify either TLSLIBDIR or both TLSLIB, TLSLIB2 and TLSLIB3 (e. g. TLSLIBDIR="\somepath\lib" or TLSLIB="\somepath\mbedtls.lib" TLSLIB2="\somepath\mbedx509.lib" TLSLIB3="\somepath\mbedcrypto.lib").
+!		ENDIF
 !	ELSE
 !		IF ("$(TLSLIBDIR)" == "" && "$(TLSLIB)" == "") || ("$(TLSLIBDIR)" != "" && "$(TLSLIB)" != "")
 !			ERROR Please specify only one of TLSLIBDIR or TLSLIB (e. g. TLSLIBDIR="\somepath\lib" or TLSLIB="\somepath\lib\some.lib").
@@ -44,6 +48,14 @@ ADDMSG =		You may specify path to library using TLSLIB="\somepath\lib\some.lib"
 TLSLIB =		$(TLSLIBDIR)\mbedtls.lib
 !		ENDIF
 CFLAGS =	$(CFLAGS) /DHAVE_POLARSSL
+	### mbed TLS 2.1.x ###
+!	ELSEIF "$(TLS)" == "mbedtls21"
+!		IF "$(TLSLIBDIR)" != ""
+TLSLIB =		$(TLSLIBDIR)\mbedtls.lib
+TLSLIB2 =		$(TLSLIBDIR)\mbedx509.lib
+TLSLIB3 =		$(TLSLIBDIR)\mbedcrypto.lib
+!		ENDIF
+CFLAGS =	$(CFLAGS) /DHAVE_MBEDTLS21
 	### GnuTLS ###
 !	ELSEIF "$(TLS)" == "gnutls"
 CFLAGS =	$(CFLAGS) /DHAVE_GNUTLS
@@ -66,11 +78,16 @@ CFLAGS =	$(CFLAGS) /DHAVE_OPENSSL
 !	IF !EXISTS("$(TLSLIB)")
 !		ERROR TLS library "$(TLSLIB)" not found. $(ADDMSG)
 !	ENDIF
-
-!	IF "$(TLS)" == "openssl"
+!	IF "$(TLS)" == "openssl" || "$(TLS)" == "mbedtls21"
 !		IF !EXISTS("$(TLSLIB2)")
 !			ERROR TLS library "$(TLSLIB2)" not found. $(ADDMSG)
 !		ENDIF
+!		IF "$(TLS)" == "mbedtls21"
+!			IF !EXISTS("$(TLSLIB3)")
+!				ERROR TLS library "$(TLSLIB3)" not found. $(ADDMSG)
+!			ENDIF
+LIBS =		$(LIBS) "$(TLSLIB)" "$(TLSLIB2)" "$(TLSLIB3)"
+!		ENDIF
 LIBS =		$(LIBS) "$(TLSLIB)" "$(TLSLIB2)"
 !	ELSE
 LIBS =		$(LIBS) "$(TLSLIB)"
diff --git a/configure.ac b/configure.ac
index c307137..f7c5223 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1349,7 +1349,7 @@ dnl Check for mbed TLS (PolarSSL) libpolarssl [by default - skip]
 LIBMBEDTLS_CHECK_CONFIG([no])
 if test "x$want_mbedtls" = "xyes"; then
 	if test "x$have_tls" != "xno"; then
-		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-gnutls or --with-openssl).])
+		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-mbedtls21, --with-gnutls or --with-openssl).])
 	fi
 
 	if test "x$found_mbedtls" != "xyes"; then
@@ -1364,11 +1364,30 @@ if test "x$want_mbedtls" = "xyes"; then
 	TLS_LIBS="$MBEDTLS_LIBS"
 fi
 
+dnl Check for mbed TLS 2.1.x (PolarSSL) libmbedtls [by default - skip]
+LIBMBEDTLS21_CHECK_CONFIG([no])
+if test "x$want_mbedtls21" = "xyes"; then
+	if test "x$have_tls" != "xno"; then
+		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-mbedtls21, --with-gnutls or --with-openssl).])
+	fi
+
+	if test "x$found_mbedtls21" != "xyes"; then
+		AC_MSG_ERROR([mbed TLS 2.1.x (PolarSSL) library libmbedtls not found])
+	elif test "x$accept_mbedtls21_version" != "xyes"; then
+		AC_MSG_ERROR([mbed TLS 2.1.x (PolarSSL) library version requirement not met (>= 2.1.9)])
+	else
+		have_tls="mbed TLS 2.1.x"
+	fi
+	TLS_CFLAGS="$MBEDTLS21_CFLAGS"
+	TLS_LDFLAGS="$MBEDTLS21_LDFLAGS"
+	TLS_LIBS="$MBEDTLS21_LIBS"
+fi
+
 dnl Check for GnuTLS libgnutls [by default - skip]
 LIBGNUTLS_CHECK_CONFIG([no])
 if test "x$want_gnutls" = "xyes"; then
 	if test "x$have_tls" != "xno"; then
-		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-gnutls or --with-openssl).])
+		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-mbedtls21, --with-gnutls or --with-openssl).])
 	fi
 
 	if test "x$found_gnutls" != "xyes"; then
@@ -1387,7 +1406,7 @@ dnl Check for OpenSSL libssl and libcrypto [by default - skip]
 LIBOPENSSL_CHECK_CONFIG([no])
 if test "x$want_openssl" = "xyes"; then
 	if test "x$have_tls" != "xno"; then
-		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-gnutls or --with-openssl).])
+		AC_MSG_ERROR([You can configure for only one TLS library (--with-mbedtls, --with-mbedtls21, --with-gnutls or --with-openssl).])
 	fi
 
 	if test "x$found_openssl" != "xyes"; then
diff --git a/include/comms.h b/include/comms.h
index 11d875e..7b23f95 100644
--- a/include/comms.h
+++ b/include/comms.h
@@ -72,7 +72,7 @@ zbx_buf_type_t;
 #define ZBX_SOCKET_COUNT	256
 #define ZBX_STAT_BUF_LEN	2048
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 typedef struct zbx_tls_context	zbx_tls_context_t;
 #endif
 
@@ -83,7 +83,7 @@ typedef struct
 	size_t				read_bytes;
 	char				*buffer;
 	char				*next_line;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_tls_context_t		*tls_ctx;
 #endif
 	unsigned int 			connection_type;	/* type of connection actually established: */
diff --git a/include/dbcache.h b/include/dbcache.h
index 73a5d8d..c278ad4 100644
--- a/include/dbcache.h
+++ b/include/dbcache.h
@@ -110,7 +110,7 @@ typedef struct
 	unsigned char	status;
 	unsigned char	tls_connect;
 	unsigned char	tls_accept;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	char		tls_issuer[HOST_TLS_ISSUER_LEN_MAX];
 	char		tls_subject[HOST_TLS_SUBJECT_LEN_MAX];
 	char		tls_psk_identity[HOST_TLS_PSK_IDENTITY_LEN_MAX];
@@ -420,7 +420,7 @@ void	DCrequeue_proxy(zbx_uint64_t hostid, unsigned char update_nextcheck);
 void	DCconfig_set_proxy_timediff(zbx_uint64_t hostid, const zbx_timespec_t *timediff);
 int	DCcheck_proxy_permissions(const char *host, const zbx_socket_t *sock, zbx_uint64_t *hostid, char **error);
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 size_t	DCget_psk_by_identity(const unsigned char *psk_identity, unsigned char *psk_buf, size_t psk_buf_len);
 #endif
 
diff --git a/include/zbxnix.h b/include/zbxnix.h
index cba7e2b..b0e5767 100644
--- a/include/zbxnix.h
+++ b/include/zbxnix.h
@@ -20,7 +20,7 @@
 #ifndef ZABBIX_ZBXNIX_H
 #define ZABBIX_ZBXNIX_H
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 int	zbx_coredump_disable(void);
 #endif
 
diff --git a/m4/libmbedtls21.m4 b/m4/libmbedtls21.m4
new file mode 100644
index 0000000..61c0dbb
--- /dev/null
+++ b/m4/libmbedtls21.m4
@@ -0,0 +1,148 @@
+# mbed TLS 2.1.x (PolarSSL) LIBMBEDTLS21_CHECK_CONFIG ([DEFAULT-ACTION])
+# ----------------------------------------------------------
+# Derived from libssh2.m4 written by
+#    Alexander Vladishev                      Oct-26-2009
+#    Dmitry Borovikov                         Feb-13-2010
+#
+# Checks for mbed TLS 2.1.x (PolarSSL) library libmbedtls.  DEFAULT-ACTION
+# is the string yes or no to specify whether to default to --with-mbedtls21 or
+# --without-mbedtls21. If not supplied, DEFAULT-ACTION is no.
+#
+# This macro #defines HAVE_MBEDTLS21 if a required header files are
+# found, and sets @MBEDTLS21_LDFLAGS@, @MBEDTLS21_CFLAGS@ and @MBEDTLS21_LIBS@
+# to the necessary values.
+#
+# Users may override the detected values by doing something like:
+# MBEDTLS21_LIBS="-lmbedtls -lmbedx509 -lmbedcrypto" MBEDTLS21_CFLAGS="-I/usr/myinclude" ./configure
+#
+# This macro is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
+
+AC_DEFUN([LIBMBEDTLS21_TRY_LINK],
+[
+AC_TRY_LINK(
+[
+#include <mbedtls/ssl.h>
+],
+[
+	mbedtls_ssl_context	ssl;
+
+	mbedtls_ssl_init(&ssl);
+],
+found_mbedtls21="yes",)
+])dnl
+
+AC_DEFUN([LIBMBEDTLS21_ACCEPT_VERSION],
+[
+	# Zabbix minimal supported version of libmbedtls:
+	minimal_mbedtls21_version_major=2
+	minimal_mbedtls21_version_minor=1
+	minimal_mbedtls21_version_patch=9
+
+	# get version
+	found_mbedtls21_version_major=`cat $1 | $EGREP \#define.*MBEDTLS_VERSION_MAJOR | $AWK '{print @S|@3;}'`
+	found_mbedtls21_version_minor=`cat $1 | $EGREP \#define.*MBEDTLS_VERSION_MINOR | $AWK '{print @S|@3;}'`
+	found_mbedtls21_version_patch=`cat $1 | $EGREP \#define.*MBEDTLS_VERSION_PATCH | $AWK '{print @S|@3;}'`
+
+	if test $((found_mbedtls21_version_major)) -gt $((minimal_mbedtls21_version_major)); then
+		accept_mbedtls21_version="yes"
+	elif test $((found_mbedtls21_version_major)) -lt $((minimal_mbedtls21_version_major)); then
+		accept_mbedtls21_version="no"
+	elif test $((found_mbedtls21_version_minor)) -gt $((minimal_mbedtls21_version_minor)); then
+		accept_mbedtls21_version="yes"
+	elif test $((found_mbedtls21_version_minor)) -lt $((minimal_mbedtls21_version_minor)); then
+		accept_mbedtls21_version="no"
+	elif test $((found_mbedtls21_version_patch)) -ge $((minimal_mbedtls21_version_patch)); then
+		accept_mbedtls21_version="yes"
+	else
+		accept_mbedtls21_version="no"
+	fi;
+])dnl
+
+AC_DEFUN([LIBMBEDTLS21_CHECK_CONFIG],
+[
+  AC_ARG_WITH(mbedtls21,[
+If you want to use encryption provided by mbed TLS 2.1.x (PolarSSL) library:
+AC_HELP_STRING([--with-mbedtls21@<:@=DIR@:>@],[use mbed TLS 2.1.x (PolarSSL) package @<:@default=no@:>@, DIR is the libmbedtls install directory.])],
+    [
+	if test "$withval" = "no"; then
+	    want_mbedtls21="no"
+	    _libmbedtls21_dir="no"
+	elif test "$withval" = "yes"; then
+	    want_mbedtls21="yes"
+	    _libmbedtls21_dir="no"
+	else
+	    want_mbedtls21="yes"
+	    _libmbedtls21_dir=$withval
+	fi
+	accept_mbedtls21_version="no"
+    ],[want_mbedtls21=ifelse([$1],,[no],[$1])]
+  )
+
+  if test "x$want_mbedtls21" = "xyes"; then
+     AC_MSG_CHECKING(for mbed TLS 2.1.x (PolarSSL) support)
+
+     if test "x$_libmbedtls21_dir" = "xno"; then
+       if test -f /usr/local/include/mbedtls/version.h; then
+         MBEDTLS21_CFLAGS=-I/usr/local/include
+         MBEDTLS21_LDFLAGS=-L/usr/local/lib
+         MBEDTLS21_LIBS="-lmbedtls -lmbedx509 -lmbedcrypto"
+         found_mbedtls21="yes"
+         LIBMBEDTLS21_ACCEPT_VERSION([/usr/local/include/mbedtls/version.h])
+       elif test -f /usr/include/mbedtls/version.h; then
+         MBEDTLS21_CFLAGS=-I/usr/include
+         MBEDTLS21_LDFLAGS=-L/usr/lib
+         MBEDTLS21_LIBS="-lmbedtls -lmbedx509 -lmbedcrypto"
+         found_mbedtls21="yes"
+         LIBMBEDTLS21_ACCEPT_VERSION([/usr/include/mbedtls/version.h])
+       else			# libraries are not found in default directories
+         found_mbedtls21="no"
+         AC_MSG_RESULT(no)
+       fi
+     else
+       if test -f $_libmbedtls21_dir/include/mbedtls/version.h; then
+         MBEDTLS21_CFLAGS=-I$_libmbedtls21_dir/include
+         MBEDTLS21_LDFLAGS=-L$_libmbedtls21_dir/lib
+         MBEDTLS21_LIBS="-lmbedtls -lmbedx509 -lmbedcrypto"
+         found_mbedtls21="yes"
+         LIBMBEDTLS21_ACCEPT_VERSION([$_libmbedtls21_dir/include/mbedtls/version.h])
+       else
+         found_mbedtls21="no"
+         AC_MSG_RESULT(no)
+       fi
+     fi
+  fi
+
+  if test "x$found_mbedtls21" = "xyes"; then
+    am_save_cflags="$CFLAGS"
+    am_save_ldflags="$LDFLAGS"
+    am_save_libs="$LIBS"
+
+    CFLAGS="$CFLAGS $MBEDTLS21_CFLAGS"
+    LDFLAGS="$LDFLAGS $MBEDTLS21_LDFLAGS"
+    LIBS="$LIBS $MBEDTLS21_LIBS"
+
+    found_mbedtls21="no"
+    LIBMBEDTLS21_TRY_LINK([no])
+
+    CFLAGS="$am_save_cflags"
+    LDFLAGS="$am_save_ldflags"
+    LIBS="$am_save_libs"
+
+    if test "x$found_mbedtls21" = "xyes"; then
+      AC_DEFINE([HAVE_MBEDTLS21], 1, [Define to 1 if you have the 'libmbedtls' 2.1.x library (-lmbedtls -lmbedx509 -lmbedcrypto)])
+      AC_MSG_RESULT(yes)
+    else
+      AC_MSG_RESULT(no)
+      MBEDTLS21_CFLAGS=""
+      MBEDTLS21_LDFLAGS=""
+      MBEDTLS21_LIBS=""
+    fi
+  fi
+
+  AC_SUBST(MBEDTLS21_CFLAGS)
+  AC_SUBST(MBEDTLS21_LDFLAGS)
+  AC_SUBST(MBEDTLS21_LIBS)
+
+])dnl
diff --git a/src/libs/zbxcomms/comms.c b/src/libs/zbxcomms/comms.c
index 213788a..3f31cec 100644
--- a/src/libs/zbxcomms/comms.c
+++ b/src/libs/zbxcomms/comms.c
@@ -439,7 +439,7 @@ static int	zbx_socket_create(zbx_socket_t *s, int type, const char *source_ip, c
 		THIS_SHOULD_NEVER_HAPPEN;
 		return FAIL;
 	}
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (ZBX_TCP_SEC_TLS_PSK == tls_connect && '\0' == *tls_arg1)
 	{
 		zbx_set_socket_strerror("cannot connect with PSK: PSK not available");
@@ -510,7 +510,7 @@ static int	zbx_socket_create(zbx_socket_t *s, int type, const char *source_ip, c
 		goto out;
 	}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if ((ZBX_TCP_SEC_TLS_CERT == tls_connect || ZBX_TCP_SEC_TLS_PSK == tls_connect) &&
 			SUCCEED != zbx_tls_connect(s, tls_connect, tls_arg1, tls_arg2, &error))
 	{
@@ -546,7 +546,7 @@ static int	zbx_socket_create(zbx_socket_t *s, int type, const char *source_ip, c
 		THIS_SHOULD_NEVER_HAPPEN;
 		return FAIL;
 	}
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (ZBX_TCP_SEC_TLS_PSK == tls_connect && '\0' == *tls_arg1)
 	{
 		zbx_set_socket_strerror("cannot connect with PSK: PSK not available");
@@ -620,7 +620,7 @@ static int	zbx_socket_create(zbx_socket_t *s, int type, const char *source_ip, c
 		return FAIL;
 	}
 
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if ((ZBX_TCP_SEC_TLS_CERT == tls_connect || ZBX_TCP_SEC_TLS_PSK == tls_connect) &&
 			SUCCEED != zbx_tls_connect(s, tls_connect, tls_arg1, tls_arg2, &error))
 	{
@@ -653,13 +653,13 @@ static ssize_t	zbx_tcp_write(zbx_socket_t *s, const char *buf, size_t len)
 {
 	ssize_t	res;
 	int	err;
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	char	*error = NULL;
 #endif
 #if defined(_WINDOWS)
 	double	sec;
 #endif
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (NULL != s->tls_ctx)	/* TLS connection */
 	{
 		if (ZBX_PROTO_ERROR == (res = zbx_tls_write(s, buf, len, &error)))
@@ -1232,7 +1232,7 @@ int	zbx_tcp_accept(zbx_socket_t *s, unsigned int tls_accept)
 	/* if the 1st byte is 0x16 then assume it's a TLS connection */
 	if (1 == res && '\x16' == buf)
 	{
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 		if (0 != (tls_accept & (ZBX_TCP_SEC_TLS_CERT | ZBX_TCP_SEC_TLS_PSK)))
 		{
 			char	*error = NULL;
@@ -1287,7 +1287,7 @@ out:
  ******************************************************************************/
 void	zbx_tcp_unaccept(zbx_socket_t *s)
 {
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	zbx_tls_close(s);
 #endif
 	if (!s->accepted) return;
@@ -1468,7 +1468,7 @@ static ssize_t	zbx_tcp_read(zbx_socket_t *s, char *buf, size_t len)
 #if defined(_WINDOWS)
 	double	sec;
 #endif
-#if defined(HAVE_POLARSSL) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
+#if defined(HAVE_POLARSSL) || defined(HAVE_MBEDTLS21) || defined(HAVE_GNUTLS) || defined(HAVE_OPENSSL)
 	if (NULL != s->tls_ctx)	/* TLS connection */
 	{
 		char	*error = NULL;
